var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
/*
 * @Author: 邱狮杰
 * @Date: 2022-09-06 23:48:36
 * @LastEditTime: 2022-09-25 10:32:23
 * @Description:
 * @FilePath: /repo/packages/vite-plugin-img-reload/src/context.ts
 */
import { createFile, ensureDir, pathExists, readdir, writeFile } from 'fs-extra';
import { base64 } from 'lqip';
import { resolve } from 'path';
const constant = {
    constantCollectionFilename: 'base64.ts',
};
export class ImgReloadContext {
    constructor(ops) {
        this.ops = { resourcePathDir: '', outputDir: '' };
        this.ops = ops;
    }
    genOutputDir() {
        var _a, _b;
        ((_a = this.ops) === null || _a === void 0 ? void 0 : _a.outputDir) && ensureDir((_b = this.ops) === null || _b === void 0 ? void 0 : _b.outputDir);
    }
    genResourcePathDir() {
        var _a, _b;
        ((_a = this.ops) === null || _a === void 0 ? void 0 : _a.resourcePathDir) && ensureDir((_b = this.ops) === null || _b === void 0 ? void 0 : _b.resourcePathDir).then(() => this.processingResourcePathDir());
    }
    // 文件名转变量名
    filenameConversionVariable(fileName) {
        return fileName.replace(/(\.|-)/g, '_');
    }
    processingResourcePathDir() {
        this.ops.resourcePathDir &&
            readdir(this.ops.resourcePathDir, { encoding: 'utf-8' }).then((res) => __awaiter(this, void 0, void 0, function* () {
                // @ts-ignore
                let soureceList = res.map(p => {
                    var _a;
                    return {
                        joinSourcePath: resolve((_a = this.ops) === null || _a === void 0 ? void 0 : _a.resourcePathDir, p),
                        fileName: p,
                    };
                });
                for (const key in soureceList) {
                    try {
                        const base64Source = yield base64(soureceList[key].joinSourcePath);
                        const outPutFilePath = resolve(this.ops.outputDir, constant.constantCollectionFilename);
                        soureceList[key] = Object.assign(Object.assign({}, soureceList[key]), { base64Source,
                            outPutFilePath });
                    }
                    catch (_a) { }
                }
                const outPutFilePath = resolve(this.ops.outputDir, constant.constantCollectionFilename);
                const content = soureceList.map(n => `export const ${this.filenameConversionVariable(n.fileName)} = '${n.base64Source}';`).join('\r\n');
                pathExists(outPutFilePath).then(hasFile => {
                    if (hasFile)
                        return;
                    createFile(outPutFilePath).then(() => {
                        writeFile(outPutFilePath, content, { encoding: 'utf-8' });
                    });
                });
            }));
    }
}
